#!/var/local/gna/bin/perl5
#
# Globewide Network Academy
# Front desk script
#
# Copyright (c) 1995-1997 - Globewide Network Academy
# Distributed under the terms of the GNU Public License
#
# Please inform dbedit\@gnacademy.org of any improvements or enhancements
# you have made to this system.


# Someday all of this information will be in a web configurable database
# system.

require 'config.pl';
require 'newlist.pl';
use Carp;
use IO::File;



sub gna_frontdesk_get_footer {
    local($queue, $id) = @_;
    local($return_address) = &gna_frontdesk_get_from($queue);
    return <<EOP;

------------------------------------------------------------------------
This e-mail was generated by the mail handling system for the 
Globewide Network Academy (http://www.gnacademy.org/).

To reply, e-mail $return_address
with the string "$prefix$id" somewhere in the header
EOP
}

use CGI qw(:cgi-lib);
require 'gna-lib.pl';
require 'newlist.pl';
use Status;

$idfile = $rootdir . "/idfile";
$unread_file = $rootdir . "/unread";
$status_handle = Status->new($rootdir . "/status");

sub gna_frontdesk_get_request_dbfile {
    return $requestdb;
}

sub gna_frontdesk_get_new_id {
    if (!-e $idfile) {
	open (FILE, ">$idfile") || croak "Cannot open frontdesk id file" ;
	print FILE "aaaaaaaa\n";
	close (FILE);
    }
    return "b" . &gna_get_time;
}

sub gna_frontdesk_get_prefix {
    return $prefix; 
}


sub gna_frontdesk_permissions {
    local($queue, $fileid) = @_;
    local($filename) = &gna_frontdesk_get_filename($queue, $fileid);
    &gna_frontdesk_permissions_filename($filename);
}

sub gna_frontdesk_permissions_filename {
    local($filename) = @_;
    `chgrp $group $filename`;
    chmod 0666, $filename;
}


sub gna_frontdesk_open {
    local ($filehandle, $queue, $fileid) = @_;
    local($filename) = &gna_frontdesk_get_filename ($queue, $fileid);
    if (!-e $filename) {
	$return_val =
	    open ($filehandle, ">$filename");
    } else {
	$return_val =
	    open ($filehandle, ">>$filename");
    }
    &gna_frontdesk_permissions($queue, $fileid);
    return $return_val;
}

sub gna_frontdesk_close {
    local ($filehandle) = @_;
    return close ($filehandle);
}

sub gna_frontdesk_get_filename {
    local ($queue, $fileid) = @_;
    return $rootdir . "/queues/" . $queue . "/" . $prefix . $fileid . ".fd";
}

sub gna_frontdesk_get_queue_path {
    local ($queue) = @_;
    return $rootdir . "/queues/" . $queue;
}

sub gna_frontdesk_queue_exists {
    local ($queue) = @_;
    return -d &gna_frontdesk_get_queue_path($queue);
}

sub gna_frontdesk_create_queue {
    local ($queue) = @_;
    if ($queue ne "" && $queue !~ /\//) {
	$dir = &gna_frontdesk_get_queue_path($queue);
	`mkdir $dir
chgrp $group $dir
chmod ug+w $dir`;
    } else {
	croak "Illegal queue name $queue";
    }
}

sub gna_frontdesk_get_subject {
    my($queue, $file) = @_;
    local(%header);
    &gna_frontdesk_get_mail_header($queue, $file, *header);
    
    $subject = $header{"Subject"};

    if ($subject !~ "^\s*Re:") {
	$subject = "Re: " . $subject;
    }

    if (! &gna_frontdesk_has_file_tag($subject)) {
	$subject = &gna_frontdesk_add_file_tag($queue, $file, $subject);
    }
    return $subject;
}


sub gna_frontdesk_get_queue_files {
    local ($queue, $search) = @_;
    local (@files, $search_list);
    local ($chunk_size) = 250;
    local ($start, $end, $command, @all_files);
	
    chdir ("$rootdir/queues/$queue");
    opendir (DIRHANDLE, "$rootdir/queues/$queue");
    @all_files = readdir(DIRHANDLE);
    closedir(DIRHANDLE);

    if ($search ne "") {
        $search_list = "";
	$search =~ s/\s+/;/gi;
        for ($i=0; $i <= $#all_files; $i += $chunk_size) {
            $start = $i;
            $end = $i + $chunk_size - 1;
            if ($end > $#all_files) { $end = $#all_files; }
            $command = "$programs{'agrep'} -i -l \"$search\" " . join (" ", @all_files[$start .. $end]);
	    $search_list .= `$command`;
	    }
@search_list = split(/\s+/, $search_list);
    } else {
@search_list = @all_files;
}

    foreach (@search_list) {
	if (/$prefix([^\/]+)\.fd$/) {
	    push (@files, $1);
	}
    }
    return @files;
}

sub gna_frontdesk_select_queue {
    my ($queue, $search, $maxcount) = @_;
    print "<form method=get action=listqueue>
<input type=hidden name=date value=\"", &gna_frontdesk_get_date,
"\">\nQueue:";
        &gna_frontdesk_queue_select_box("queue", $queue);
    print "<input name=do_search value=Yes type=checkbox> ",
        "Search for ",     "<input size=12 name=search value=\"", $search, "\">",
    " <input name=do_maxcount value=Yes type=checkbox> ",
    "Limit to ", 
    "<select name=maxcount>
<option value=0 selected>(no limit)
	<option>5
	    <option>10
		<option>20
<option>50
		    <option>100
			<option>200
			    <option>500
				<option>1000</select>"; 
	print " <input type=submit value=\"View queue\"></form><hr>";
}

sub gna_frontdesk_list_queue {
        my ($queue, $search, $maxcount) = @_;
	my(@list);
	my($count) = 0;
	print "<title>$title -- Listing queue $queue</title>";
	&gna_frontdesk_select_queue($queue, $search, $maxcount);



	print '<form method=post action=movequeue>', "\n";
        print "<input type=checkbox name=do_movequeue checked value=yes>";
	print "Move items to ";
	&gna_frontdesk_queue_select_box("newqueue", "done");
        print "<input type=checkbox name=do_movestatus value=yes>";
	print " Set status to ";
	&gna_frontdesk_status_select_box("newstatus", "");
	print '<input type=submit name=do_move value="Do it">';
	print "<br>\n";
    
	print " <a href=\"comment?queue=$queue\">Compose e-mail</a><p>\n";

      fileloop:
        foreach $file 
	    (reverse(sort(&gna_frontdesk_get_queue_files($queue, $search)))) {
		if ($maxcount > 0 && $count >= $maxcount) {
		    last fileloop;
		}
	    &gna_frontdesk_get_mail_header($queue, $file, *header);
	    $print_from = &gna_frontdesk_htmlize($header{'From'});
	    $print_to = &gna_frontdesk_htmlize($header{'To'});
	    $status = $status_handle->get_status($file);
	    $unread = $status ne "" ? 
		"<b>[" . $status . "]</b>" : "";
	    print &gna_frontdesk_expand_hrefs(<<EOP);
[<input type=checkbox name=file value=$file> Select] 
[<a href=\"showfile?file=$file\">Show file</a>] $unread<br>
$print_from to  $print_to<br>
Subject: $header{'Subject'}<br>
Date: $header{'Date'}<br>
EOP
	    print "<hr>\n";
$count++;

}
        print "</form><P>";
}


sub gna_frontdesk_header {
	print "Expires: Tuesday, 01-Jan-80 00:00:00 GMT\n";
        print &PrintHeader;
	print $header;
	flush;
}

sub gna_frontdesk_footer {
        print <<EOP;
<hr>
Copyright (c) 1995-1998
<A HREF="http://www.gnacademy.org:8001/uu-gna/index.html">
Globewide Network Academy</A><br>
Distributed under the terms of the GNU Public License
EOP
}

sub gna_frontdesk_send_info {
    local ($queue, $file, $to, $file_type) = @_;
    
    $mail_header = &gna_frontdesk_get_prefix;
    $subject = &gna_frontdesk_get_subject($queue, $file);

    foreach $info_file (&gna_frontdesk_get_info_files($file_type)) {
	if (!-r $info_file) {
	    croak "Cannot find info file: $info_file";
	}

	&gna_send_file(&gna_frontdesk_get_from($queue), 
		       $to, $subject, $info_file );
    }
    $date = &gna_frontdesk_get_date;
    $who = &gna_frontdesk_who_am_i;

    &gna_frontdesk_append_comment($queue, $file, <<EOP);
--------------
Information packet e-mailed
Date: $date 
Mailed-by: $who
Mailed-to: $to
EOP
}

sub gna_frontdesk_display_file {
    my ($queue, $file) = @_;
    print "Reference: $file<br>";
    &gna_frontdesk_print_options($queue, $file);
    &gna_frontdesk_print_item($queue, $file);
    if ($status_handle->get_status($file) eq "unread") {
	$status_handle->set_status($file, "");
    }
}

sub gna_frontdesk_file_to_queue {
    my ($file) = @_;
    my ($queue);
    foreach (split(/\s+/, `echo $rootdir/queues/*`)) {
	/([^\/]+)$/;
	$queue = $1;
	if (-e &gna_frontdesk_get_filename($queue, $file)) {
	    return $queue;
	}
    }
    return "";
}


sub gna_frontdesk_print_options {
        local ($queue, $file) = @_;
        local (%header, $_);
        &gna_frontdesk_get_mail_header($queue, $file, *header);

        $reply_to = $header{'Reply-to'} ne "" ? $header{'Reply-to'} 
                : $header{'From'};
	if (($reply_to eq &gna_frontdesk_get_from($queue) ||
    &gna_frontdesk_get_from($queue) =~ /\<$reply_to\>/)

 &&
	    $header{'To'} ne "") {
	    $reply_to = $header{'To'};
	}
	$reply_to_html = &gna_frontdesk_htmlize($reply_to);
	$reply_to_cgi = &gna_cgi_quote($reply_to);

	$date = &gna_frontdesk_get_date;
	$date_cgi = &gna_cgi_quote($date);

#Include date in the CGI address so that the clients don't cache

	&gna_frontdesk_select_queue($queue);
	print "<form method=post action=movequeue>\n";
	print "<input type=hidden name=file value=$file>\n";
	print "<input type=checkbox name=do_movequeue checked value=yes>";
        print "Move items to ";
        &gna_frontdesk_queue_select_box("newqueue", "done");
        print "<br><input type=checkbox name=do_movestatus  value=yes>";
        print "Set status to ";
        &gna_frontdesk_status_select_box("newstatus", "");
        print '<br><input type=submit name=do_move value="Do it">';
        print "<br>\n";
	print "</form>";

        print <<EOP;

<A HREF="comment?file=$file&to=$reply_to_cgi&date=$date_cgi">Respond to sender</A><br>
<A HREF="comment?file=$file&date=$date_cgi">Comment or forward file</A><br>
<a href="comment?queue=$queue">Compose new e-mail</a><br>
<hr>
EOP

    foreach (keys (%url)) {
	print "<A href=\"", $_, "\">", $url{$_}, "</a><br>\n";
    }
        foreach (&gna_frontdesk_get_forward_list) {
	    if ($newqueue{$_} ne "") {
		$newqueue="&newqueue=$newqueue{$_}";
	    } else {
		$newqueue="";
	    }
	    print "<A HREF=\"comment?file=$file&reply_to=$reply_to_cgi&to=$_&include_file=Yes$newqueue&date_$date_cgi\">Forward file to $_</A><br>\n";
        }
	print <<EOP;
<hr>
EOP
}


sub gna_frontdesk_print_item {
    my ($queue, $file) = @_;
    my($output);
    $filename = &gna_frontdesk_get_filename($queue, $file);
    print "<PRE>\n";
    $output = `cat $filename | grep -v "^Received:" | grep -v "^\tid"`;
    print &gna_frontdesk_htmlize ($output);
    print "</PRE>";
}				# 

sub gna_frontdesk_htmlize {
    my ($output) = @_;


    return &gna_frontdesk_expand_hrefs(&gna_entity_quote($output));
}

sub gna_frontdesk_get_mail_header {
        local($queue, $file, *header) = @_;
        $filename = &gna_frontdesk_get_filename ($queue, $file);
        open (FILE, "$filename") || croak "Cannot open $filename";
	%header = "";
	while(<FILE>) {
	    /^\s*$/ && do {last;};
	    /^\s*([^:\s]+):\s*(.*)/ && do {$header{$1} .= $2;};
	}
        close FILE;
}

sub gna_frontdesk_append_comment {
    local ($queue, $file, $comment) = @_;
    &gna_frontdesk_open("FILE", $queue, $file) 
	|| croak "Cannot open $filename";
    s/\r//g;
    print FILE $comment;
    &gna_frontdesk_close("FILE");
}

sub gna_frontdesk_get_date {
    return &gna_get_time;
}

sub gna_frontdesk_who_am_i {
    local($username) = $ENV{"REMOTE_USER"};
    local(*key, *f);
    $key{'web_username'} = $username;
    $returnval = $username;
    if ($user{$username} ne "") {
        $returnval .= " ($user{$username})";
    }
    return ($returnval);
}

sub gna_frontdesk_get_from {
    local($queue) = @_;
    local($return_email) = $from_queue{$queue} ne "" ? 
           $from_queue{$queue} : $from;

# Include the user's real name if available
    if ($user{$ENV{"REMOTE_USER"}} ne "") {
       $return_email = "$user{$ENV{'REMOTE_USER'}} <$return_email>";
    }
    return $return_email;
}

sub gna_frontdesk_get_forward_list {
    return @forward_list;
}

sub gna_frontdesk_get_info_files {
    local($file_type) = @_;
    if ($file_type eq "") {
	return @info_files;
    } else {
	$filename = $form_letter_dir . "/" . $file_type . ".txt";
	if (-e $filename) {
	    croak "Cannot find form letter $file_type";
	}
    }
}


sub gna_frontdesk_move_status {
    my($filelist, $newstatus) = @_;
    my($file);
    foreach $file (split(/\\0/, $filelist)) {
       $status_handle->set_status($file, $newstatus);
       my($queue) = &gna_frontdesk_file_to_queue($file);
       my($date) = &gna_frontdesk_get_date;
       my($who) = &gna_frontdesk_who_am_i;
       &gna_frontdesk_append_comment($queue, $file, <<EOP);
------------
File changed to status $newstatus
Date: $date
By: $who
EOP
    print <<EOP;
Changing $file to $newstatus
EOP
   }
}

sub gna_frontdesk_move_queue {
    local($oldqueue, $file, $newqueue) = @_;
    
    if ($oldqueue eq "") {
        $error = "No queue found for file $file";
    }

    if ($newqueue eq "") {
        $error = "No new queue specified";
    } elsif (!&gna_frontdesk_queue_exists($newqueue)) {
        &gna_frontdesk_create_queue($newqueue);
    }

    $oldfilename = 
	&gna_frontdesk_get_filename($oldqueue, $file);

    $newfilename = 
	&gna_frontdesk_get_filename($newqueue, $file);

    if (!-e $oldfilename) {
        $error = "Cannot file file $oldfilename";
    } elsif (-e $newfilename) {
        $error = "New filename $newfilename already exists";
    }

    if ($error eq "") {
        print <<EOP;
Moving file $file from queue $oldqueue to $newqueue 
EOP
    `mv $oldfilename $newfilename`;
	$date = &gna_frontdesk_get_date;
	$who = &gna_frontdesk_who_am_i;
# Remove from unread list
	$mark_read{$newqueue} && 
	    $status_handle->set_status($file, "");
# Add to unread list
	$mark_unread{$newqueue} && 
	    $status_handle->set_status($file, "unread");

	&gna_frontdesk_append_comment($newqueue, $file, <<EOP);
--------------
File moved from queue $oldqueue to $newqueue
Date: $date
By: $who
EOP

# Notify user that message has been moved
    my($fh) = IO::File->new(&gna_frontdesk_get_filename($newqueue, $file));
	if (defined($fh)) {
	while(<$fh>) {
	    $message .= $_;
	}
	$fh->close();
    }

	&gna_frontdesk_execute_action("movequeue", 
				      $newqueue,
				      $file,
				      $message);

	if ($notify_queue{$newqueue} ne "") {
	    local(%header, $_);
            local(*FILE);
	    local($message);
	    $message = <<EOP;
The file $file has been moved into $newqueue

EOP

	    &gna_frontdesk_get_mail_header($newqueue, $file, *header);
	    &gna_send_mail($from, $notify_queue{$newqueue},
			   "Moved to $newqueue:" . $header{"Subject"},
			   $message);
	}

} else {
        print <<EOP;
Queue move unsuccessful<br>
$error
<HR>
EOP
}
}

sub gna_frontdesk_move_queue_and_select {
    local($filelist, $newqueue) = @_;
    local($oldqueue, $file);
    foreach $file (split(/\\0/, $filelist)) {
	$oldqueue = &gna_frontdesk_file_to_queue($file);
	if ($oldqueue ne $newqueue) {
	    &gna_frontdesk_move_queue($oldqueue, $file, $newqueue);
	    print "<br>\n";
	}
    }

    print "<hr>\n";
}

sub gna_frontdesk_list_queues {
    opendir(THISDIR, "$rootdir/queues");
    local(@queue) =  sort(grep(!/^\.\.?$/,readdir(THISDIR)));
    closedir(THISDIR);
    return @queue;
}

sub gna_frontdesk_queue_select_box {
    my($name, $queue) = @_;
    print "<select name=$name>\n";
    foreach (&gna_frontdesk_list_queues) {
	print "<option ";
	if ($_ eq $queue) {
	    print "selected";
	}
	print ">";
	print $_;
	print "\n";
    }
    print "</select>\n";
}

sub gna_frontdesk_status_select_box {
    my($name, $status) = @_;
    print "<select name=$name>\n";
    print "<option ";
    if ($_ eq "") {
	print "selected";
    }
    print ' value = "">(none)', "\n";

    foreach (@gna_frontdesk_status_list) {
	print "<option ";
	if ($_ eq $queue) {
	    print "selected";
	}
	print ">";
	print $_;
	print "\n";
    }
    print "</select>\n";
}


sub gna_frontdesk_has_file_tag {
    my($string) = @_;
    return ($string =~ /$prefix\w+\b/);
}

sub gna_frontdesk_add_file_tag {
    my($queue, $file, $string) = @_;
    return "$string ($prefix$file)";
}

sub gna_frontdesk_expand_hrefs {
    local ($_) = @_;
    s/(http|gopher|telnet|https)(:\/\/[^\<\>\"\s\&\?]+(\?[^\<\>\"\s]+)*[^\&\<\>\"\s\?\,\.])/<a href=\"\1\2\">\1\2<\/a>/gi;
    return $_;
}

sub gna_frontdesk_execute_action {
    my($action_type, $queue, $id, $input) = @_;
    if ($action->{$queue}->{$action_type} ne "") {
	return &{$action->{$queue}->{$action_type}}($id, $input);
    } 
}

1;


